#include  "misc_led.h"

//#define USE_REG

#ifdef USE_REG
static  unsigned long*  ledcon = NULL;
static  unsigned long*  leddat = NULL;
#endif

void __memzero(void *s, size_t count)
{
	memset(s, 0, count);
}

static  ssize_t   led_write(struct file * filp, const char __user * buff, size_t count, loff_t * offset)
{
	char  buf[32] = {0};
	int ret = 0;

	ret = copy_from_user(buf,  buff, min(count, sizeof(buf)));

	if(strncmp(buf, "led_on", strlen("led_on")) == 0)
	{
		printk("---led on---\n");
#ifdef USE_REG
		*leddat  &= ~(1 << LEDPIN);                       //SET L
#else
		gpio_set_value(LEDRES,0);
#endif
	}
	else if(strncmp(buf, "led_off", strlen("led_off")) == 0)
	{
		printk("---led off---\n");
#ifdef USE_REG
		*leddat  |= (1 << LEDPIN);                        //SET H
#else
		gpio_set_value(LEDRES,1);
#endif
	}
	else
	{
		printk("***cmd error!***\n");
	}

	return  min(count, sizeof(buf));
}


static  struct file_operations  g_fops = {
		.owner	=	THIS_MODULE,
		.write	=	led_write,
};


static  struct miscdevice  g_misc = {
	.fops	=	&g_fops,
	.minor	=	MISC_DYNAMIC_MINOR,
	.name	=	"led_misc",
};

static  int  __init  xyd_misc_init(void)
{
        printk("---led init---\n");
#ifdef USE_REG
	ledcon = ioremap(LEDCON, 4);
	leddat = ioremap(LEDDAT, 4);

	*ledcon  &= ~(0xf << ((LEDPIN & 0x7) << 2));
	*ledcon  |= ((1 & 0x7) << ((LEDPIN & 0x7) << 2)); //SET OUT
	*leddat  |= (1 << LEDPIN);                        //SET H
#else
	 if (gpio_request(LEDRES, LEDNAME)) 
	 {
	      printk("GPIO request failure: %s\n", LEDNAME);
	      return -1;
	 }
#endif
	misc_register(&g_misc);
	return 0;
}

static  void  __exit  xyd_misc_exit(void)
{
        printk("---led exit---\n");
	misc_deregister(&g_misc);
#ifdef USE_REG
	iounmap(ledcon);
	iounmap(leddat);
#else
	gpio_free(LEDRES);
#endif
}

module_init(xyd_misc_init);
module_exit(xyd_misc_exit);

MODULE_AUTHOR("gx");
MODULE_DESCRIPTION("led driver");
MODULE_LICENSE("GPL");
MODULE_ALIAS("platform:f1c100s_led");

